unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Menus, StdCtrls, ComCtrls, ToolWin, Buttons;

type

  TSymItem = packed record
    case Integer of
    0: (P: Pointer);
    1: (C: array[0..3] of Byte);
  end;


  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Label2: TLabel;
    Label3: TLabel;
    RegGrid1: TStringGrid;
    PortGrid1: TStringGrid;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SaveAs1: TMenuItem;
    Project1: TMenuItem;
    Compile1: TMenuItem;
    Memo1: TMemo;
    ListBox1: TListBox;
    GroupBox1: TGroupBox;
    EditButton1: TSpeedButton;
    CompileButton1: TSpeedButton;
    RunButton1: TSpeedButton;
    StepButton1: TSpeedButton;
    StopButton1: TSpeedButton;
    FindDialog1: TFindDialog;
    Edit1: TMenuItem;
    EditMode1: TMenuItem;
    Find1: TMenuItem;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    ToggleBrekpoint1: TMenuItem;
    ReplaceDialog1: TReplaceDialog;
    Replace1: TMenuItem;
    New1: TMenuItem;
    SaveDialog2: TSaveDialog;
    Connect1: TMenuItem;
    Help1: TMenuItem;
    AssemblerHelpF11: TMenuItem;
    About1: TMenuItem;
    DeleteLine1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Compile1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure RunButton1Click(Sender: TObject);
    procedure StopButton1Click(Sender: TObject);
    procedure EditButton1Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Find1Click(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure Memo1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Edit1Click(Sender: TObject);
    procedure Replace1Click(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure ReplaceDialog1Find(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure File1Click(Sender: TObject);
    procedure Connect1Click(Sender: TObject);
    procedure AssemblerHelpF11Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure DeleteLine1Click(Sender: TObject);
  private
    { Private declarations }
    MemoPos: Integer;
    MemoTopRow: Integer;
    CodeList: TList;
    SymList: TStringList;
    Phase2: Boolean;
    FindIx: Integer;
    MemoI: Integer;
    ClausPos: Integer;
    LastIx: Integer;
    ErrIx: Integer;
    procedure DefaultSyms;
    function SaveIf: Boolean;
    function CompileRow(const s: String; var Cm: Integer): Boolean;
    function CompileList(List1: TStrings; MemoOn: Boolean): Boolean;
    function LoadSym(const Sp: String; var Ip: Integer): Boolean;
    function LoadCmd(const Sc: String; var Ic: Integer): Boolean;
    function PutSym(const Ss, Se: String): Boolean;
    procedure LoadRegs;
    procedure SaveHexFile;
    procedure Memo1Find(Dialog: TFindDialog);
    procedure ListBox1Find(Dialog: TFindDialog);
  public
    { Public declarations }
    EditName: String;
    procedure UpdRegs;
    procedure ListBox1ItemUpd;
    function CountCurs(R: Integer): Integer;
    function CountRow(C: Integer): Integer;
  end;

var
  Form1: TForm1;
  CodeMem: array[0..$FFF] of Byte;
  CodeIx: Integer;
  R: array[0..15] of Word; { Smallint; }
  P: array[0..15] of Word; { Smallint; }
  SingleStep: Boolean;
  RowList: TList;

implementation

{$R *.DFM}

uses Sub, Unit2, Unit3, Unit4;

const

  ComdMax = 18;
  Comds: array[0..ComdMax] of array[0..2] of Char = (
  'LDX', 'CLX', 'ANX', 'ORX', 'ADX', 'STX', 'SLX', 'SRX',
  'INX', 'DEX', 'NGX', 'BPX', 'BNX', 'RDX', 'WRX', 'MLT',
  'EQU', 'DB', 'ORG');

  ErrTxts: array[0..7] of String = (
  '', 'Double Def', 'Unknown Symbol', 'Unknown Command',
  'Phase Err', '?', '?', '?');

  ClausIx = 100;
  ClausMax = 0;
  Claus: array[0..0] of String = ('INCLUDE');


{ HEX-tiedoston rivit

 Esim tllainen lyhyt rivi:
:0302FE00806DE927

03 = dataa tll rivill tavuina kpl
02 FE = tmn rivin alkuosoite, hb ensin sitten lb, eli tss on osoite 02FE
00 = datan tyyppi, aina nolla
80 6D E9 = data tavuina, tss 3 kpl
27 = tarkistussumma, 03+02+FE+00+80+6D+E9+27=0

Tiedoston lopussa tllainen rivi:
:00000001FF
00 = datan mr 0
0000 = osoite 0000
01 = datan tyyppi: tiedoston loppu
FF = tarkistussumma

Yleens riville laitetaan 16 tai 32 tavua
 }


procedure TForm1.SaveHexFile;
var
  HexStream: TFileStream;
  i, j: Integer;
  s: String;
begin
  if CodeIx > 0 then
  begin
    HexStream := TFileStream.Create(ChangeFileExt(EditName, '.HEX'), fmCreate);
    try
      i := 0;
      repeat
        if i + 16 > CodeIx then j := CodeIx - i else j := 16;
        s := BinToHexStr(CodeMem[i], i, j);
        HexStream.Write(s[1], Length(s));
        Inc(i, j);
      until i >= CodeIx;
      HexStream.Write(EndHexStr[1], Length(EndHexStr));
    finally
      HexStream.Free;
    end;
  end;  
end;

{ lasketaan kursoripaikka rivinumeron perusteella }
function TForm1.CountCurs(R: Integer): Integer;
begin
  if R > Memo1.Lines.Count then R := Memo1.Lines.Count;
  Result := SendMessage(Memo1.Handle, EM_LINEINDEX, R, 0);
end;

{ lasketaan rivinumero kursoripaikkan perusteella }
function TForm1.CountRow(C: Integer): Integer;
begin
  if C < 0 then C := 0;
  Result := SendMessage(Memo1.Handle, EM_LINEFROMCHAR, C, 0);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  EditName := '';
  CodeList := TList.Create;
  SymList := TStringList.Create;
  SymList.Sorted := True;
  RowList := TList.Create;
  FillChar(CodeMem, SizeOf(CodeMem), $FF);
  for i := 0 to 15 do
  begin
    R[i] := 0;
    P[i] := 0;
    with RegGrid1.Cols[0] do Strings[i] := 'R' + IntToHex(i,1);
    with PortGrid1.Cols[0] do Strings[i] := 'P' + IntToHex(i,1);
  end;
  with RegGrid1.Cols[0] do
  begin
    Strings[0] := Strings[0] + '  P';
    Strings[1] := Strings[1] + '  A';
    Strings[3] := Strings[3] + '  N';
    Strings[4] := Strings[4] + '  M';
    Strings[5] := Strings[5] + '   I';
  end;
  UpdRegs;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  if SaveIf then
  with OpenDialog1 do
  if Execute then
  with Memo1 do
  begin
    Caption := ExtractFileName(FileName);
    if FileExists(FileName)
    then Lines.LoadFromFile(FileName)
    else Lines.Clear;
    EditName := FileName;
    MemoPos := -1;
    MemoTopRow := -1;
    Modified := False;
  end;
end;

function TForm1.SaveIf: Boolean;
begin
  Result := False;
  if Memo1.Modified then
  case MessageDlg('Save Changes?', mtConfirmation,
                  mbYesNoCancel, 0) of
    mrCancel: Exit;
    mrYes: Save1Click(Self);
  end;
  Result := True;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
  if EditName = ''
  then SaveAs1Click(Sender)
  else Memo1.Lines.SaveToFile(EditName);
  Memo1.Modified := False;
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
begin
  if CompileButton1.Down then
  with SaveDialog2 do
  begin
    FileName := ChangeFileExt(EditName, '.l');
    if Execute then ListBox1.Items.SaveToFile(EditName);
  end
  else
  with SaveDialog1 do
  begin
    FileName := EditName;
    if Execute then
    begin
      EditName := FileName;
      Caption := ExtractFileName(EditName);
      Memo1.Lines.SaveToFile(EditName);
    end;
  end;
end;

procedure TForm1.DefaultSyms;
var
  i: Integer;
begin
  with SymList do
  begin
    for i := 0 to 15 do
    begin
      AddObject('R' + HexChar[i], Pointer($10000 + i));
      AddObject('P' + HexChar[i], Pointer($20000 + i));
    end;
    AddObject('P', Pointer($10000));
    AddObject('A', Pointer($10001));
    AddObject('N', Pointer($10003));
    AddObject('M', Pointer($10004));
    AddObject('I', Pointer($10005));
  end;
end;

function TForm1.PutSym(const Ss, Se: String): Boolean;
var
  i, ix: Integer;
begin
  i := StrToIntDef(Se, $80000000);
  if (i = $80000000) and not LoadSym(Se, i) then i := $80000000;
  if Phase2 and (i = $80000000) then ErrIx := 2
  else if not Phase2 and SymList.Find(Ss, ix) then ErrIx := 1
  else SymList.AddObject(Ss, Pointer(i));
  Result := ErrIx = 0;
end;

function TForm1.LoadSym(const Sp: String; var Ip: Integer): Boolean;
var
  i: Integer;
  IsNeg: Boolean;
  S1: String;
begin
  Ip := 0;
  if (Length(Sp) = 0) or ((Length(Sp) = 1) and (Sp[1] = '-')) then
  begin
    Result := False;
    ErrIx := 2;
    Exit;
  end;
  if not Phase2
  then Result := True
  else
  begin
    S1 := UpperCase(Sp);
    IsNeg := S1[1] = '-';
    if IsNeg then Delete(S1, 1, 1);
    if (Length(S1) > 3) and (S1[Length(S1)] = #39)
    and (S1[2] = #39) then
    case S1[1] of
      'B': S1 := Copy(S1, 3, Length(S1) - 3) + S1[1];
      'D': S1 := Copy(S1, 3, Length(S1) - 3);
      'H': S1 := '0' + Copy(S1, 3, Length(S1) - 3) + S1[1];
    end;
    Result := S1[1] in NumSet;      { luku }
    if Result then
    begin
      if S1[Length(S1)] = 'B'       { binriluku }
      then i := BinToInt(S1)
      else if S1[Length(S1)] = 'H'  { hexaluku }
      then i := StrToIntDef('$' + Copy(S1, 1, Length(S1) - 1), $80000000)
      else i := StrToIntDef(S1, $80000000); { desimaaliluku }
      Result := i <> $80000000;
    end;
    if Result
    then Ip := i
    else
    begin
      Result := SymList.Find(S1, i);
      if Result then Ip := Integer(Pointer(SymList.Objects[i]));
    end;
    if Result and IsNeg then Ip := -Ip;
  end;
  if not Result then ErrIx := 2;
end;

function TForm1.LoadCmd(const Sc: String; var Ic: Integer): Boolean;
var
  i: Integer;
begin
  Result := False;
  if Length(Sc) = 0 then Exit;
  if Length(Sc) in [2..3] then
  begin
    for i:= 0 to ComdMax do if Equal(Sc[1], Comds[i], Length(Sc)) then
    begin
      Ic := i;
      Result := True;
      Break;
    end;
  end
  else
  for i:= 0 to ClausMax do if Sc = Claus[i] then
  begin
    Ic := i + ClausIx;
    Result := True;
    Break;
  end;
  if not Result then ErrIx := 3;
end;

function TForm1.CompileRow(const s: String; var Cm: Integer): Boolean;
var
  Ix, Ic, Ip, Id, Ie: Integer;
  Sl, Sc, Sp: String;
begin
  Cm := -1;
  Result := True;
  if Length(s) = 0 then Exit;
  Ix := 1;
  Sl := '';
  if s[1] in NameSet then
  begin
    while (Ix <= Length(s)) and (s[Ix] in NameSet) do Inc(Ix);  {name}
    Sl := UpperCase(Copy(s, 1, Ix - 1));
    if s[Ix] = ':' then
    if (not Phase2) and SymList.Find(Sl, Ic) then
    begin  { on jo olemassa }
      Result := False;
      ErrIx := 1;
      Exit;
    end
    else SymList.AddObject(Sl, Pointer(CodeIx));
  end;

  while (Ix <= Length(s)) and not (s[Ix] in NameSet) do Inc(Ix);  { spaces }
  if Length(s) >= Ix + 2 then
  begin
    Sc := UpperCase(NextText(s, Ix));    { command }
    if LoadCmd(Sc, Ic) then
    begin
      if Ic >= ClausIX
      then ClausPos := Ix
      else if Ic = 15 then                { MLT }
      begin
        CodeMem[CodeIx and $FFF] := $F3;
        Inc(CodeIx);
      end
      else if (Ic = 17) then              { DB }
      begin
        while (Length(s) > Ix)
        and LoadSym(NextText(s, Ix), Id) do
        begin
          CodeMem[CodeIx and $FFF] := Lo(Id);
          Inc(CodeIx);
        end;
      end
      else if Ic = 18 then                { ORG }
      begin
        if CodeIx <> 0 then
        begin
          ErrIx := 4;
          Result := False
        end
        else
        begin
          CodeMem[CodeIx and $FFF] := $10;
          CodeIx := 1;
        end;  
      end
      else
      begin
        Sp := UpperCase(NextText(s, Ix));    { param 1 }
        if LoadSym(Sp, Ip) then
        begin
          if (Ic = 16) and (Length(Sl) > 0)   { EQU }
          then
          begin
            if not PutSym(Sl, Sp) then Result := False; { double def }
          end
          else if Ic = 0 then
          begin                               { LDX }
            Sp := UpperCase(NextText(s, Ix));    { param 2 }
            if LoadSym(Sp, Id) then
            begin
              ErrIx := 0;
              while (Length(s) > Ix) and (s[Ix] in ['+', '-'])
              and LoadSym(NextText(s, Ix), Ie) do
              begin
                Id := Id + Ie;
              end;
              if ErrIx <> 0 then Result := False;
              CodeMem[CodeIx and $FFF] := Lo(Ip);
              Inc(CodeIx);
              CodeMem[CodeIx and $FFF] := Hi(Id);
              Inc(CodeIx);
              CodeMem[CodeIx and $FFF] := Lo(Id);
              Inc(CodeIx);
            end
            else Result := False;
          end
          else
          begin
            CodeMem[CodeIx and $FFF] := Lo(Ic) shl 4 + (Lo(Ip) and 15);
            Inc(CodeIx);
          end;
        end
        else Result := False;
      end;
    end
    else Result := False;
    Cm := Ic;
  end;
end;

{const
  TabSpace: array[0..9] of Integer = (
  32, 64, 96, 128, 160, 192, 224, 256, 288, 320); }

function TForm1.CompileList(List1: TStrings; MemoOn: Boolean): Boolean;
var
  i, j, ix, Cm: Integer;
  s, ApuS: String;
  ApuList: TStringList;
begin
  Result := True;
  ErrIx := 0;
  with List1 do
  begin
    if Count > 0 then
    for i := 0 to Count - 1 do
    begin
      if MemoOn then MemoI := i;
      s := Strings[i];
      j := Pos(';', s);
      if j > 0 then SetLength(s, j);
      ix := CodeIx;
      Result := CompileRow(s, Cm);
      if Result and Phase2 then
      begin
        ApuS := '                ' + Strings[i];
        if CodeIx > ix then
        begin { pivitetn Memo2 }
          PutStr(IntToHex(ix, 3), ApuS, 2);
          PutStr(IntToHex(CodeMem[ix], 2), ApuS, 6);
          LastIx := ListBox1.Items.Count;
          if RowList.Count > ix
          then RowList.Items[ix] := Pointer(LastIx);
          if Cm = 0 then  { LDX }
          PutStr(IntToHex((CodeMem[ix+1] shl 8) + CodeMem[ix+2], 4), ApuS, 9)
          else if (Cm = 17) then { DB }
          begin
            Inc(ix);
            j := 9;
            while (CodeIx > ix) and (j < 15) do
            begin
              PutStr(IntToHex(CodeMem[ix], 2), ApuS, j);
              Inc(ix);
              Inc(j, 3);
            end;
            if CodeIx > ix then PutStr('..', ApuS, 14);
          end;
        end;
        if not MemoOn then ApuS[16] := '|';
        ListBox1.Items.Add(ApuS);
      end;

      if Result and (Cm = ClausIx) then
      begin   { Include file }
        ApuS := NextName(s, ClausPos);
        if Pos('\', ApuS) = 0
        then ApuS := ExtractFileDir(EditName) + '\' + ApuS;
        if FileExists(ApuS) then
        begin
          ApuList := TStringList.Create;
          ApuList.LoadFromFile(ApuS);
          Result := CompileList(ApuList, False);
          ApuList.Free;
        end;
      end;

      if not Result then
      with Memo1 do
      begin
        SelStart := CountCurs(MemoI);
        SelLength := Length(Lines[MemoI]);
        ShowMessage('Error: ' + ErrTxts[ErrIx and 7]);
        Break;
      end;

    end;
  end;
end;

procedure TForm1.ListBox1ItemUpd;
var
  i: Integer;
begin
  i := (R[0] + 1) and $FFFF;
  if RowList.Count > i then
  ListBox1.ItemIndex := Integer(RowList.Items[i]) and $FFFF;
end;

procedure TForm1.Compile1Click(Sender: TObject);
var
  Virhe: Boolean;


begin
  Virhe := True;
  if EditName = '' then SaveAs1Click(Sender);
  if EditName <> '' then
  begin
    Phase2 := True;
    CodeList.Clear;
    SymList.Clear;
    DefaultSyms;
    ListBox1.Clear;
    RowList.Clear;
    MemoI := 0;
    LastIx := 0;
    repeat
      Phase2 := not Phase2;
      CodeIx := 0;
      FillChar(CodeMem, SizeOf(CodeMem), $FF);

      Virhe := not CompileList(Memo1.Lines, True);

      if not Phase2 and not Virhe then
      begin
        RowList.Clear;
        RowList.Capacity := CodeIx + 1;
        RowList.Count := CodeIx + 1;
      end;
    until Virhe or Phase2;

  end;
  if not Virhe and (CodeIx > 0) then
  begin
    if RowList.Count > CodeIx
    then RowList.Items[CodeIx] := Pointer(LastIx + 1);
    SaveHexFile;
    CompileButton1.Caption := 'Simulation';
    RunButton1.Enabled := True;
    StepButton1.Enabled := True;
    Memo1.Hide;
    ListBox1.Width := Memo1.Width;
    ListBox1.Align := alLeft;
    ListBox1.Show;
    R[0] := 0;
    RegGrid1.Cells[1, 0] := '0';
    ListBox1.ItemIndex := -1;
    ListBox1ItemUpd;
  end
  else EditButton1.Down := True;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;


procedure TForm1.UpdRegs;
var
  i: Integer;
begin
  for i := 0 to 15 do RegGrid1.Cols[1][i] := IntToStr(R[i]);
  for i := 0 to 15 do PortGrid1.Cols[1][i] := IntToStr(P[i]);
end;

procedure TForm1.LoadRegs;
var
  i: Integer;
begin
  for i := 0 to 15 do R[i] := StrToIntDef(RegGrid1.Cols[1][i], 0);
  for i := 0 to 15 do P[i] := StrToIntDef(PortGrid1.Cols[1][i], 0);
  UpdRegs;
end;

procedure TForm1.RunButton1Click(Sender: TObject);
var
  i, j: Integer;
begin
  with RowList do
  if Count > 0 then
  for i := 0 to Count - 1 do
  begin
    j := Integer(Items[i]) and $FFFF;
    if (ListBox1.Items.Count > j)
    and (Length(ListBox1.Items[j]) > 0)
    and (ListBox1.Items[j][1] = '>')
    then Items[i] := Pointer(Integer(Items[i]) or $80000000)
    else Items[i] := Pointer(Integer(Items[i]) and $FFFF);
  end;
  SingleStep := TButton(Sender).Tag = 1;
  RunButton1.Enabled := False;
  StepButton1.Enabled := False;
  LoadRegs;
  DebugThread := TDebug.Create(False);
  StopButton1.Enabled := True;
end;

procedure TForm1.StopButton1Click(Sender: TObject);
begin
  if DebugThread <> nil then DebugThread.Terminate;
end;

procedure TForm1.EditButton1Click(Sender: TObject);
begin
  ListBox1.Hide;
  Memo1.Show;
  RunButton1.Enabled := False;
  StepButton1.Enabled := False;
  CompileButton1.Caption := 'Compile';
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
var
  s: String;
begin
  with ListBox1 do
  if ItemIndex >= 0 then
  begin
    s := Items[ItemIndex];
    if (Length(s) > 2) and (s[2] <> ' ') then
    begin
      if s[1] = ' ' then s[1] := '>' else s[1] := ' ';
      Items[ItemIndex] := s;
    end;
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := SaveIf;
end;

procedure TForm1.Memo1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button in [mbRight]
  then PopupMenu1.Popup(x, y);
end;

procedure TForm1.ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button in [mbRight]
  then PopupMenu2.Popup(Form1.Left + x, Form1.Top +
  Form1.Height - Form1.ClientHeight + y);
end;

procedure TForm1.Edit1Click(Sender: TObject);
begin
  EditMode1.Checked := EditButton1.Down;
  Replace1.Enabled := EditButton1.Down;
end;

procedure TForm1.Find1Click(Sender: TObject);
begin
  FindDialog1.Left := 400;
  FindIx := -1;
  FindDialog1.Execute;
end;

procedure TForm1.FindDialog1Find(Sender: TObject);
begin
  if ListBox1.Visible
  then ListBox1Find(FindDialog1)
  else Memo1Find(FindDialog1);
end;

procedure TForm1.Replace1Click(Sender: TObject);
begin
  ReplaceDialog1.Left := 400;
  FindIx := -1;
  ReplaceDialog1.Execute;
end;

procedure TForm1.ReplaceDialog1Find(Sender: TObject);
begin
  Memo1Find(ReplaceDialog1);
end;

procedure TForm1.ReplaceDialog1Replace(Sender: TObject);
begin
  repeat
    ReplaceDialog1Find(Sender);
    if FindIx > 0 then
    Memo1.SetSelTextBuf(PChar(ReplaceDialog1.ReplaceText));
  until not (frReplaceAll in ReplaceDialog1.Options) or (FindIx <= 0);
end;

procedure TForm1.Memo1Find(Dialog: TFindDialog);
begin
  FindIx := LStrPosIC(Dialog.FindText, Memo1.Text, FindIx + 2);
  if FindIx > 0 then with Memo1 do
  begin
    SelStart := FindIx-1;
    SelLength := Length(Dialog.FindText);
  end
  else Dialog.CloseDialog;
end;

procedure TForm1.ListBox1Find(Dialog: TFindDialog);
var
  i: Integer;
begin
  Inc(FindIx);
  if ListBox1.Items.Count > FindIx then
  begin
    for i := FindIx to ListBox1.Items.Count - 1 do
    if LStrPosIC(Dialog.FindText, ListBox1.Items[i], 1) > 0 then
    begin
      FindIx := i;
      ListBox1.ItemIndex := i;
      Exit;
    end;
    Dialog.CloseDialog;
  end
  else Dialog.CloseDialog;
end;

procedure TForm1.New1Click(Sender: TObject);
begin
  if SaveIf then
  begin
    Memo1.Clear;
    EditName := '';
    Caption := 'New';
  end;
end;

procedure TForm1.File1Click(Sender: TObject);
begin
  New1.Enabled := EditButton1.Down;
  Open1.Enabled := New1.Enabled;
  Save1.Enabled := New1.Enabled;
end;


procedure TForm1.Connect1Click(Sender: TObject);
begin
 { Form3 := TForm3.Create(Self);
  Form3.ShowModal; }
  Form3.Show;
end;

procedure TForm1.AssemblerHelpF11Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  Application.HelpContext(1);
end;

procedure TForm1.DeleteLine1Click(Sender: TObject);
var
  R: Integer;
begin
  with Memo1 do
  if Visible then
  begin
    R := CountRow(SelStart);
    SelStart := CountCurs(R);
    SelLength := CountCurs(R+1) - SelStart;
    ClearSelection;
  end;
end;

end.
