unit Unit2;

interface

uses
  Classes;

type
  TDebug = class(TThread)
  private
    { Private declarations }
    procedure DoEnd;
  protected
    procedure Execute; override;
  end;

var
  DebugThread: TDebug;

implementation

uses Windows, Messages, SysUtils, Unit1;

{ Important: Methods and properties of objects in VCL can only be used in a
  method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure TDebug.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ TDebug }

procedure TDebug.DoEnd;
begin
  with Form1 do
  begin
    UpdRegs;
    RunButton1.Enabled := True;
    StepButton1.Enabled := True;
    StopButton1.Enabled := False;
    ListBox1ItemUpd;
  end;
end;

procedure TDebug.Execute;
var
  Kasky, i: Integer;
  Valmis: Boolean;
begin
  Valmis := CodeMem[(R[0] + 1) and $FFF] = $FF;
  if Valmis then R[0] := $FFFF
  else
  repeat
    Inc(R[0]);  { MAX1463 single step increments PC before instruction not after }
    Kasky := CodeMem[R[0] and $FFF];
    case (Kasky shr 4) and $F of
      0: begin                             { LDX }
           Inc(R[0], 2);
           R[Kasky and $F] := (CodeMem[(R[0] - 1) and $FFF] shl 8)
                            + (CodeMem[R[0] and $FFF]);
         end;
      1: R[Kasky and $F] := 0;             { CLX }
      2: R[1] := R[1] and R[Kasky and $F]; { ANX }
      3: R[1] := R[1] or R[Kasky and $F];  { ORX }
      4: R[1] := R[1] + R[Kasky and $F];   { ADX }
      5: R[Kasky and $F] := R[1];          { STX }
      6: if Kasky and $F = 6               { SLX }
         then R[6] := (R[6] shl 1) or ((R[4] shr 15) and 1)
         else R[Kasky and $F] := R[Kasky and $F] shl 1;
      7: R[Kasky and $F] :=                { SRX }
         R[Kasky and $F] shr 1 or (R[Kasky and $F] and $8000);
      8: Inc(R[Kasky and $F]);             { INX }
      9: Dec(R[Kasky and $F]);             { DEX }
      10: R[Kasky and $F] := not R[Kasky and $F]; { NGX }
      11: if R[5] and $8000 = 0            { BPX }
          then R[0] := R[0] + R[Kasky and $F] - 1;
      12: if R[5] <> 0                     { BNX }
          then R[0] := R[0] + R[Kasky and $F] - 1;
      13: R[1] := P[Kasky and $F];         { RDX }
      14: P[Kasky and $F] := R[1];         { WRX }
      15: if Kasky and $F = 3 then         { MLT }
          begin
            i := R[3] * R[4];
            R[4] := LongRec(i).Lo;
            R[1] := LongRec(i).Hi;
          end
          else
          begin
            Dec(R[0]);
            Valmis := True;
          end;
    end;
  {  Inc(R[0]);  single step do not increment PC after instruction but before }
  until SingleStep or Valmis
      or ((RowList.Count > R[0]) and (Integer(RowList.Items[R[0]]) < 0) )
      or Terminated;
  Synchronize(DoEnd);
end;

end.
