unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Buttons;

type
  TForm3 = class(TForm)
    GroupBox1: TGroupBox;
    Button2: TButton;
    WritePort1: TButton;
    ReadPort1: TButton;
    PortEdit1: TEdit;
    ComList1: TComboBox;
    PortList1: TComboBox;
    ReadA1: TButton;
    ReadPC1: TButton;
    AccuEdit1: TEdit;
    PcEdit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    StartCPU1: TButton;
    StopCPU1: TButton;
    StepCPU1: TButton;
    ResetPC1: TButton;
    ResetAll1: TButton;
    WriteFlash1: TButton;
    ReadFlash1: TButton;
    FlashDataEdit1: TEdit;
    FlashAdrEdit1: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    EraseFlash1: TButton;
    Button3: TButton;
    GroupBox2: TGroupBox;
    ProgName1: TEdit;
    OpenButton1: TSpeedButton;
    StartButton1: TButton;
    CancelButton1: TButton;
    ProgressBar1: TProgressBar;
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    Button1: TButton;
    ActionsButton1: TButton;
    UpDown1: TUpDown;
    Label5: TLabel;
    WriteFlash2: TButton;
    ReadFlash2: TButton;
    SignP1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComList1Change(Sender: TObject);
    procedure PortList1Change(Sender: TObject);
    procedure WritePort1Click(Sender: TObject);
    procedure ReadPort1Click(Sender: TObject);
    procedure ReadA1Click(Sender: TObject);
    procedure ResetPC1Click(Sender: TObject);
    procedure ReadPC1Click(Sender: TObject);
    procedure StopCPU1Click(Sender: TObject);
    procedure StartCPU1Click(Sender: TObject);
    procedure StepCPU1Click(Sender: TObject);
    procedure ResetAll1Click(Sender: TObject);
    procedure FlashAdrEdit1Change(Sender: TObject);
    procedure WriteFlash1Click(Sender: TObject);
    procedure ReadFlash1Click(Sender: TObject);
    procedure EraseFlash1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure OpenButton1Click(Sender: TObject);
    procedure ActionsButton1Click(Sender: TObject);
    procedure StartButton1Click(Sender: TObject);
    procedure CancelButton1Click(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure SignP1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    hPort: THandle;
    ComIx: Integer;
    PortIx: Integer;
    procedure ClosePort;
    procedure IncFlashAdr;
  public
    { Public declarations }
    procedure Send8(B: Integer);
    function ReadDHR: Integer;
    procedure Send16(i, ofs: Integer);
    procedure SendDHR(i: Integer);
    procedure WriteToFlash(Adr, Dat: Integer);
    procedure WriteToPort(p, d: Integer);
    procedure EnableFlashWrite;
  end;

var
  Form3: TForm3;

implementation

{$R *.DFM}

uses Unit1, Unit5;

procedure TForm3.Button1Click(Sender: TObject);
var
  Dcb: TDCB;
begin
  if hPort <> INVALID_HANDLE_VALUE then Exit;
  hPort := CreateFile(PChar(ComList1.Items[ComList1.ItemIndex]),
         GENERIC_READ or GENERIC_WRITE,
         0, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
  if hPort <> INVALID_HANDLE_VALUE then
  begin
    ZeroMemory(@Dcb, SizeOf(Dcb));
    with Dcb do
    begin
      DCBlength := SizeOf(Dcb);
      BaudRate := CBR_9600;       { ei merkityst }
    end;
    SetCommState(hPort, Dcb);
    ActionsButton1.Show;
    ActionsButton1.Caption := 'Actions';
    GroupBox2.Enabled := True;
  end
  else MessageDlg(ComList1.Items[ComList1.ItemIndex] + '-portti ei toimi', mtError, [mbOK], 0);
end;

procedure TForm3.ClosePort;
begin
  if hPort <> INVALID_HANDLE_VALUE then CloseHandle(hPort);
  hPort := INVALID_HANDLE_VALUE;
  ActionsButton1.Hide;
  GroupBox1.Hide;
  GroupBox2.Enabled := False;
  Height := ActionsButton1.Top + ActionsButton1.Height + 50;
end;

procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ClosePort;
end;


procedure TForm3.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
  if ComList1.ItemIndex < 0 then ComList1.ItemIndex := 0;
  ComIx := ComList1.ItemIndex;
  PortList1.ItemIndex := 0;
  PortIx := 0;
  hPort := INVALID_HANDLE_VALUE;
  Height := ActionsButton1.Top + ActionsButton1.Height + 50;
end;

procedure TForm3.ComList1Change(Sender: TObject);
begin
  if ComList1.ItemIndex <> ComIx then
  begin
    ClosePort;
    ComIx := ComList1.ItemIndex;
  end;
end;

procedure TForm3.PortList1Change(Sender: TObject);
begin
  if PortList1.ItemIndex <> PortIx then
  begin
    PortEdit1.Text := '';
    PortIx := PortList1.ItemIndex;
  end;
end;

procedure TForm3.Send8(B: Integer);
var
  i: Integer;
begin
  EscapeCommFunction(hPort, SETBREAK);      { /CS = 0 }
 { Sleep(10); }
  for i := 0 to 7 do
  begin
    if (B and 1 <> 0)
    then EscapeCommFunction(hPort, CLRRTS)  { Data = 1 }
    else EscapeCommFunction(hPort, SETRTS); { Data = 0 }
    EscapeCommFunction(hPort, SETDTR);      { Clk = 0 }
    B := B shr 1;
{    Sleep(10); }
    EscapeCommFunction(hPort, CLRDTR);      { Clk = 1 }
{    Sleep(10); }
  end;
  EscapeCommFunction(hPort, SETDTR);        { Clk = 0 }
  EscapeCommFunction(hPort, CLRBREAK);      { /CS = 1 }
{  Sleep(10); }
end;

function TForm3.ReadDHR: Integer;
var
  i: Integer;
  ModStat: DWORD;
begin
  Result := 0;
  Send8($19);
  EscapeCommFunction(hPort, SETBREAK);                { /CS = 0 }
{  Sleep(10);  }
  for i := 0 to 15 do
  begin
    EscapeCommFunction(hPort, CLRDTR); { Clk = 1 }
    Result := Result shl 1;
    GetCommModemStatus(hPort, ModStat);
    EscapeCommFunction(hPort, SETDTR);                { Clk = 0 }
    if ModStat and MS_DSR_ON = 0 then Result := Result or 1;
  end;
  EscapeCommFunction(hPort, CLRBREAK);                { /CS = 1 }
end;

procedure TForm3.Send16(i, ofs: Integer);
begin
  Send8(((i shl 4)and $F0) + ofs);
  Send8((i and $F0) + ofs + $01);
  Send8(((i shr 4) and $F0) + ofs + $02);
  Send8(((i shr 8) and $F0) + ofs + $03);
end;

procedure TForm3.SendDHR(i: Integer);
begin
  Send16(i, 0);
end;

procedure TForm3.WriteToPort(p, d: Integer);
begin
  Send16(p and 15, $04);    { send port adr to PFAR }
  SendDHR(d);               { send data to DHR }
  Send8($08);               { write DHR to port }
end;

procedure TForm3.WritePort1Click(Sender: TObject);
begin
  WriteToPort((PortList1.ItemIndex and 15),     { port adr }
    StrToIntDef(PortEdit1.Text, 0));            { data }
end;

procedure TForm3.ReadPort1Click(Sender: TObject);
begin
  Send16((PortList1.ItemIndex and 15), $04);    { send port adr to PFAR }
  Send8($28);                                   { get port data to DHR }
  if SignP1.Checked
  then PortEdit1.Text := IntToStr(SmallInt(ReadDHR))
  else PortEdit1.Text := IntToStr(ReadDHR);     { read data from DHR }
end;

procedure TForm3.ReadA1Click(Sender: TObject);
begin
  Send8($48);
  AccuEdit1.Text := IntToStr(ReadDHR);
end;

procedure TForm3.ResetPC1Click(Sender: TObject);
begin
  Send8($A8);
end;

procedure TForm3.ReadPC1Click(Sender: TObject);
begin
  Send8($68);
  PcEdit1.Text := IntToHex(ReadDHR, 1);
end;

procedure TForm3.StopCPU1Click(Sender: TObject);
begin
  Send8($78);
end;

procedure TForm3.StartCPU1Click(Sender: TObject);
begin
  Send8($88);
end;

procedure TForm3.StepCPU1Click(Sender: TObject);
begin
  Send8($98);
end;

procedure TForm3.ResetAll1Click(Sender: TObject);
begin
  Send8($B8);
end;

procedure TForm3.FlashAdrEdit1Change(Sender: TObject);
begin
  FlashDataEdit1.Text := '';
  UpDown1.Position := StrToIntDef('$' + FlashAdrEdit1.Text, 0);
end;

procedure TForm3.EnableFlashWrite;
begin
  Send8($78);                  { stop CPU }
  WriteToPort($0D, $1000);      { write $1000 to port D }
  WriteToPort($0E, $0031);      { write $0031 to port E }
  WriteToPort($0F, $8000);      { write $8000 to port F }
end;

procedure TForm3.WriteToFlash(Adr, Dat: Integer);
begin
  Send16(Adr and $FFF, $04);  { send flash adr to PFAR }
  SendDHR(Dat);               { send data to DHR }
  Send8($18);                 { write DHR to flash }
  Sleep(1);
end;

procedure TForm3.IncFlashAdr;
begin
  FlashAdrEdit1.Text :=
  IntToHex((StrToIntDef('$' + FlashAdrEdit1.Text, 0) + 1) and $FFF , 1);
end;

procedure TForm3.WriteFlash1Click(Sender: TObject);
begin
{  EnableFlashWrite; }
  if TControl(Sender).Tag = 1 then IncFlashAdr;
  WriteToFlash(StrToIntDef('$' + FlashAdrEdit1.Text, 0) and $FFF,
    StrToIntDef('$' + FlashDataEdit1.Text, 0));
{  Send8($B8);  }
end;

procedure TForm3.ReadFlash1Click(Sender: TObject);
begin
  if TControl(Sender).Tag = 1 then IncFlashAdr;
  Send16((StrToIntDef('$' + FlashAdrEdit1.Text, 0) and $FFF), $04); { send flash adr to PFAR }
  Send8($38);                                                       { get flash data to DHR }
  FlashDataEdit1.Text := IntToHex(ReadDHR and $FF, 2);              { read data from DHR }
end;

procedure TForm3.EraseFlash1Click(Sender: TObject);
begin
{  EnableFlashWrite; }
  Send8($E8);
  Sleep(10);
 { Send8($B8); }
end;

procedure TForm3.Button3Click(Sender: TObject);
begin
  EnableFlashWrite;
end;


procedure TForm3.Timer1Timer(Sender: TObject);
begin
  if hPort = INVALID_HANDLE_VALUE then
  with Button1 do
  begin
    if Timer1.Tag = 0
    then Button1.Caption := 'Port'
    else Button1.Caption := 'Open';
    Timer1.Tag := Timer1.Tag xor 1;
  end;
  if ProgressOn
  then ProgressBar1.Position := ProgressIx
  else EndProgress := False;
  if EndProgress then ProgressOn := False;
end;


procedure TForm3.OpenButton1Click(Sender: TObject);
begin
  with OpenDialog1 do
  begin
    FileName := ProgName1.Text;
    if Execute then
    begin
      ProgName1.Text := FileName;
      ProgName1.SelStart := Length(ProgName1.Text);
    end;
  end;
end;


procedure TForm3.ActionsButton1Click(Sender: TObject);
begin
  if GroupBox1.Visible then
  begin
    GroupBox1.Hide;
    ActionsButton1.Caption := 'Actions';
    Height := ActionsButton1.Top + ActionsButton1.Height + 50;
  end
  else
  begin
    GroupBox1.Show;
    ActionsButton1.Caption := 'Hide';
    Height := GroupBox1.Top + GroupBox1.Height + 50;
  end;
end;

procedure TForm3.StartButton1Click(Sender: TObject);
begin
  UpLoad1 := TUpLoad.Create(False);
end;

procedure TForm3.CancelButton1Click(Sender: TObject);
begin
  ProgressOn := False;
end;

procedure TForm3.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  FlashAdrEdit1.Text := IntToHex(UpDown1.Position, 1);
end;

procedure TForm3.SignP1Click(Sender: TObject);
var
  Ix: Word;
begin
  Ix := StrToIntDef(PortEdit1.Text, 0);
  if SignP1.Checked
  then PortEdit1.Text := IntToStr(SmallInt(Ix))
  else PortEdit1.Text := IntToStr(Ix);     { read data from DHR }
end;

procedure TForm3.FormShow(Sender: TObject);
begin
  ProgName1.Text := ChangeFileExt(Form1.EditName, '.hex');
  ProgName1.SelStart := Length(ProgName1.Text);
end;

end.
