unit Unit4;

interface

uses SysUtils;

function NextText(const S: String; var Ix: Integer): String;
function NextName(const S: String; var Ix: Integer): String;

procedure PutStr(const s1: String; var s2: String; p: Integer);

{ Hex-tiedoston rivi }
function BinToHexStr(var BinJono; Adr, Pit: Integer): String;

{ Hex-file to bytearray. BinS=bytearray, BinLen=length, BinKpl=result length }
function HexFileToBin(const HexFile: String; BinS: PByteArray; BinLen: Integer;
         var BinKpl: Integer): Boolean;

         { binary string to integer conversion
  If error then Result = $80000000 }
function BinToInt(const S: String): Integer;

const
  HexChar: array[0..15] of Char = '0123456789ABCDEF';

  NumSet = ['0'..'9'];
  UpCSet = ['A'..'Z'];
  ExtSet = ['_'];
  LowCSet = ['a'..'z'];
  HexSet = NumSet + ['A'..'F'];
  NameSet = NumSet + UpCSet + ExtSet + LowCSet;

  EndHexStr: String = ':00000001FF'#13#10;

implementation

uses Windows;

function NextText(const S: String; var Ix: Integer): String;
var
  Iy: Integer;
begin
  Result := '';
  if Ix > Length(S) then Exit;
  while (Ix <= Length(S)) and not (S[Ix] in NameSet + ['-']) do Inc(Ix);
  Iy := Ix;
  Inc(Ix);
  while (Ix <= Length(S)) and (S[Ix] in NameSet + [#39]) do Inc(Ix);   {#39 = "'"}
  Result := Copy(S, Iy, Ix - Iy);
end;

function NextName(const S: String; var Ix: Integer): String;
var
  Iy: Integer;
begin
  Result := '';
  if Ix > Length(S) then Exit;
  while (Ix <= Length(S)) and (S[Ix] <= ' ') do Inc(Ix);
  Iy := Ix;
  Inc(Ix);
  while (Ix <= Length(S)) and (S[Ix] > ' ') do Inc(Ix);
  Result := Copy(S, Iy, Ix - Iy);
end;


procedure PutStr(const s1: String; var s2: String; p: Integer);
var
  i: Integer;
begin
  i := Length(s1);
  if i + p - 1 > Length(s2) then i := Length(s2) - p + 1;
  if (i > 0) and (p > 0) then Move(s1[1], s2[p], i);
end;

{ Hex-tiedoston rivi }
function BinToHexStr(var BinJono; Adr, Pit: Integer): String;
var
  i, c: Integer;
begin
  if (Pit > 0) and (Pit < 256) then
  begin
    Result := ':' + IntToHex(Lo(Pit), 2)
      + IntToHex(Hi(Adr), 2) + IntToHex(Lo(Adr), 2) + '00';
    c := Pit + Hi(Adr) + Lo(Adr);       { chksum }
    for i := 0 to Pit - 1 do
    begin
      c := c + TByteArray(BinJono)[i];
      Result := Result + IntToHex(TByteArray(BinJono)[i], 2);
    end;
    Result := Result + IntToHex(Lo(-c), 2) + #13#10;
  end
  else Result := '';
end;


function HexFileToBin(const HexFile: String; BinS: PByteArray; BinLen: Integer;
         var BinKpl: Integer): Boolean;
var
  HexF: TextFile;
  Rivi: String;
  ApuC, ApuM: Integer;
  Valmis: Boolean;

  function RiviToMem: Boolean;
  var
    Ix, Iy: Integer;
    ChkS: Byte;
  begin
    Result := True;
    ApuC := StrToIntDef('$' + Copy(Rivi, 2, 2), 0);
    ApuM := StrToIntDef('$' + Copy(Rivi, 4, 4), 0);
    if (ApuC > 0) and (ApuM >= 0)
    and (ApuM + ApuC <= BinLen) then
    begin
      if ApuM + ApuC > BinKpl then BinKpl := ApuM + ApuC;
      ChkS := (ApuC + Hi(ApuM) + Lo(ApuM)) and $FF;
      Iy := 10;
      for Ix := ApuM to ApuM + ApuC - 1 do
      begin
        BinS^[Ix] := StrToIntDef('$' + Copy(Rivi, Iy, 2), 0);
        ChkS := (ChkS + BinS^[Ix]) and $FF;
        Inc(Iy, 2);
      end;
      Result := (ChkS + StrToIntDef('$' + Copy(Rivi, Iy, 2), 0)) and $FF = 0;
    end;
  end;

begin
  BinKpl := 0;
  FillMemory(BinS, BinLen, $FF);
  AssignFile(HexF, HexFile);
  Reset(HexF);
  Result := IOResult = 0;
  if Result then
  repeat
    Readln(HexF, Rivi);
    Valmis := (IOResult <> 0) or Eof(HexF);
    if not Valmis then
    Result := RiviToMem;
  until not Result or Valmis;
  CloseFile(HexF);
end;

{ binary string to integer conversion
  If error then Result = $80000000 }
function BinToInt(const S: String): Integer;
var
  i: Integer;
begin
  Result := $80000000;
  for i := 1 to Length(S) do
  begin
    if S[i] in ['0', '1'] then
    begin
      Result := Result shl 1;
      if S[i] = '1' then Inc(Result);
    end
    else
    begin
      if UpCase(S[i]) <> 'B' then Result := $80000000;
      Break;
    end;
  end;
end;

end.
