unit Unit5;

interface

uses
  Classes;

type
  TUpLoad = class(TThread)
  private
    { Private declarations }
    procedure EndProgressBar;
  protected
    procedure Execute; override;
  end;

var
  UpLoad1: TUpLoad;
  ProgressOn: Boolean = False;
  EndProgress: Boolean = False;
  ProgressIx: Integer = 0;

implementation

uses Windows, Unit3, Unit4, SysUtils;

{ Important: Methods and properties of objects in VCL can only be used in a
  method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure TUpLoad.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ TUpLoad }

var PHexJono: PByteArray;

procedure TUpLoad.Execute;
var
  BinKpl, Ix: Integer;
begin
  if FileExists(Form3.ProgName1.Text) then
  begin
    GetMem(PHexJono, $1000);
    try
      if HexFileToBin(Form3.ProgName1.Text, PHexJono,
              $1000, BinKpl)
      and (BinKpl > 0) then with Form3 do
      begin
        EndProgress := False;
        ProgressOn := True;
        EnableFlashWrite;
        Send8($E8);           { erase flash }
        Sleep(100);
        for Ix := 0 to BinKpl - 1 do
        begin
          ProgressIx := MulDiv(Ix, 100, BinKpl);
          if not ProgressOn then Break;
          WriteToFlash(Ix, PHexJono^[Ix]);
        end;
        Send8($B8);           { disable write }
      end;
    finally
      FreeMem(PHexJono);
    end;
  end;
  ProgressIx := 100;
  EndProgress := True;
  repeat
    Sleep(100);
  until not ProgressOn;
  with Form3 do
  begin
    Send8($B8);  { reset modules }
    Send8($A8);  { reset PC }
    Send8($88);  { start program }
  end;
  Synchronize(EndProgressBar);
end;

procedure TUpLoad.EndProgressBar;
begin
  Form3.ProgressBar1.Position := 0;
  ProgressOn := False;
end;

end.
